/**************************************************************************
* iptrk - ip tracker
* Copyright (C) 2003 Jason Nunn <jsno@leal.com.au>
* Darwin, NT, Australia.
* Originally developed for Arafura Connect (Dec 2000 - Mar 2003)
* Donated to GPL before liquidation.
*
* =======================================================================
*
**************************************************************************/
#include <curses.h>
#include "defs.h"

PRIVATE WINDOW *win;
PRIVATE int    posy,
               posx,
               lim;
PRIVATE char   *strp;

/**************************************************************************
*
**************************************************************************/
PUBLIC void getstr_rt_init(WINDOW *w, int y, int x, int l, char *s)
{
  win = w;
  posy = y;
  posx = x;
  lim = l;
  strp = s;
  strp[0] = 0;
}

/**************************************************************************
*
**************************************************************************/
PUBLIC int getstr_rt(void)
{
  int ch, l;

  ch = wgetch(win);
  if(ch == ERR)
    return 0;

  l = strlen(strp);

  if(ch < ' ' || ch > 'z') /*special characters*/
  {
    if(ch == KEY_CR)
      return 1;

    if(ch == KEY_DC || ch == KEY_BSPACE)
      if(l > 0)
      {
        strp[l - 1] = 0;
        mvhline(posy, posx, ' ', l);
        waddstr(win, strp);
      }

    return 0;
  }

  if(l >= lim)
  {
    beep();
    return 0;
  }

  strp[l] = ch;
  strp[l + 1] = 0;
  move(posy, posx);
  waddstr(win, strp);
  return 0;
}
